//Cosmin Negruseri
#include <stdio.h>
#include <stdlib.h>

int n;
char a[1000004],b[1000004],c[1000004],res[1000004];

int u[6]; // buckets
// 0 - different
// 1 - A=B
// 2 - A=C
// 3 - B=C
// 4 - A=B=C

int move[5];
// 0 - move from BC bucket to A
// 1 - move from A to B
// 2 - move from AC to B
// 3 - move from A to C
// 4 - move from AB to C

FILE *fl;

int whichcase(char va,char vb, char vc)
{
	if (va==vb && va==vc) return 4;
	if (va==vb) return 1;
	if (va==vc) return 2;
	if (vb==vc) return 3;
	return 0;
}

int mymin(int a, int b)
{
	if (a<b) return a;
	return b;
}

void docount()
{
	int i;
	char va,vb,vc;
	for (i=0; i<n; i++)
	{
		u[whichcase(a[i],b[i],c[i])]++;
	}
}

void produce()
{
	int i,mode;
	for (i=0; i<n; i++)
	{
		mode=whichcase(a[i],b[i],c[i]);
		switch(mode)
		{
		case 0:
			if (move[1]-- >0) res[i]=b[i];
			else if (move[3]-- >0) res[i]=c[i];
			else res[i]=a[i];
			break;
		case 1:
			if (move[4]-- >0) res[i]=c[i];
			else res[i]=a[i];
			break;
		case 2:
			if (move[2]-- >0) res[i]=b[i];
			else res[i]=a[i];
			break;
		case 3:
			if (move[0]-- >0) res[i]=a[i];
			else res[i]=b[i];
			break;
		case 4:
			res[i]=a[i];
			break;
		}
	}
	res[n]=0;
}

inline int dista()
{
	return u[3]-move[0]+move[1]+move[2]+move[3]+move[4];
}

inline int distb()
{
	return u[0]+u[2]+move[0]-move[1]-move[2];
}

inline int distc()
{
	return u[0]+u[1]+move[0]-move[3]-move[4];
}



void balance()
{
	fprintf(fl,"DISTS: %d %d %d\n",dista(),distb(),distc());
	if (dista()>distb() && dista()>distc())
	{
		// too many in the BC bucket and A is poor
		move[0]=mymin(dista()-distc(),dista()-distb())/2;
		return;
	}
	while (1)
	{
		// move from one bucket to the other until it's balanced
		// move from bucket A (not equal to B or C) first
		// A to B
		if (distb()>=distc() && distb()>dista()+1 && u[0]>move[1]+move[3])
		{
			move[1]++;
			continue;
		}
		// A to C
		if (distc()>distb() && distc()>dista()+1 && u[0]>move[1]+move[3])
		{
			move[3]++;
			continue;
		}
		// move from bucket AB to C
		if (distc()>distb()+1 && distb()>dista()+1 && u[1]>move[4])
		{
			move[4]++;
			continue;
		}
		// move from bucket AC to B
		if (distb()>distc()+1 && distc()>dista()+1 && u[2]>move[2])
		{
			move[2]++;
			continue;
		}
		break;
	}
	if (!(move[2]==0 || (move[4]==0 && move[3]==0))) fprintf(fl,"we screwed up\n");
	if (!(move[4]==0 || (move[2]==0 && move[1]==0))) fprintf(fl,"we screwed up\n");
}

int main(int argc, char *argv[])
{
	fl=fopen("sm.log","w");
	freopen("cstring.in", "r", stdin);
	scanf("%d\n",&n);
	scanf("%s\n",a);
	scanf("%s\n",b);
	scanf("%s\n",c);
	fprintf(fl,"--%s--\n",a);
	fprintf(fl,"--%s--\n",b);
	fprintf(fl,"--%s--\n",c);
	docount();
	fprintf(fl,"%d %d %d %d %d\n",u[0],u[1],u[2],u[3],u[4]);
	balance();
	fprintf(fl,"after balance: %d %d %d\n",dista(),distb(),distc());
	produce();
	freopen("cstring.out", "w", stdout);
	printf("%s\n",res);
	return 0;
}
