// Mugurel Andreica - O(N)
#include <stdio.h>
#include <vector>

using namespace std;

#define NMAX 1000100

int max3(int a, int b, int c) {
	if (a >= b) {
		if (a >= c)
			return a;
		else
			return c;
	} else {
		if (b >= c)
			return b;
		else
			return c;
	}
}

int min3(int a, int b, int c) {
	if (a <= b) {
		if (a <= c)
			return a;
		else
			return c;
	} else {
		if (b <= c)
			return b;
		else
			return c;
	}
}

vector<int> v[4];
char S[3][NMAX], Sol[NMAX];
int N, dist[3], len[4];

void read_input() {
	freopen("cstring.in", "r", stdin);
	scanf("%d %s %s %s", &N, S[0], S[1], S[2]);
}

void preprocess() {
	for (int i = 0; i < N; i++) {
		if (S[0][i] == S[1][i] && S[0][i] == S[2][i])
			Sol[i] = S[0][i];
		else if (S[0][i] == S[1][i] && S[0][i] != S[2][i])
			v[0].push_back(i);
		else if (S[1][i] == S[2][i] && S[0][i] != S[1][i])
			v[1].push_back(i);
		else if (S[2][i] == S[0][i] && S[2][i] != S[1][i])
			v[2].push_back(i);
		else
			v[3].push_back(i);
	}
}

void compute() {
	int i, j, k, dmax;
	for (i = 0; i < 4; i++)
		len[i] = v[i].size();
	
	while (len[0] > 0 && len[1] > 0 && len[2] > 0) {
		Sol[v[0][len[0] - 1]] = S[0][v[0][len[0] - 1]];
		Sol[v[1][len[1] - 1]] = S[1][v[1][len[1] - 1]];
		Sol[v[2][len[2] - 1]] = S[2][v[2][len[2] - 1]];
		dist[0]++; dist[1]++; dist[2]++;
		len[0]--; len[1]--; len[2]--;
	}

	for (i = 0; i < 3; i++) {
		while (len[i] >= 1) {
			Sol[v[i][len[i] - 1]] = S[i][v[i][len[i] - 1]];
			len[i]--;
			dist[(i + 2) % 3]++;
			if (max3(dist[0], dist[1], dist[2]) - min3(dist[0], dist[1], dist[2]) >= v[3].size() + 1) {
				len[i]++;
				dist[(i + 2) % 3]--;
				Sol[v[i][len[i] - 1]] = S[(i + 2) % 3][v[i][len[i] - 1]];
				len[i]--;
				dist[i]++;
				dist[(i + 1) % 3]++;
			}
		}
	}

	for (i = 0; i < v[3].size(); i++) {
		dmax = dist[0];
		j = 0;
		for (k = 1; k < 3; k++)
			if (dist[k] > dmax) {
				dmax = dist[k];
				j = k;
			}
			
		Sol[v[3][i]] = S[j][v[3][i]];
		for (k = 0; k < 3; k++)
			if (k != j) {
				dist[k]++;
			}
	}
	
	fprintf(stderr, "dist[0]=%d, dist[1]=%d, dist[2]=%d\n", dist[0], dist[1], dist[2]);
	//fprintf(stderr, "%s\n%s\n%s\n%s\n", S[0], S[1], S[2], Sol);
}

void write_output() {
	freopen("cstring.out", "w", stdout);
	printf("%s\n", Sol);
}

int main() {
	read_input();
	preprocess();
	compute();
	write_output();
	return 0;
}
