#include<cstdio>
#include<vector>
#include<deque>
#include<algorithm>

#define infile "cstring.in"
#define outfile "cstring.out"
#define okfile "cstring.ok"

#define infileMsg "Fisier de intrare lipsa!"
#define outfileMsg "Fisier de iesire lipsa!"
#define okfileMsg "Fisier OK lipsa!"
#define okMsg "OK!"
#define wrongMsg "Raspuns Gresit!"

#define pct 10
#define lgMax 1000013

char a[lgMax], b[lgMax], c[lgMax];
char out[lgMax], ok[lgMax], customMsg[lgMax];
int n;

using namespace std;

void terminate(int p, char *m) {
	printf("%d %s\n", p, m);
	exit(0);
}

int compute(char v[]) {
  int cntA = 0, cntB = 0, cntC = 0;

  for(int i = 0; i < n; ++i) {
    if(a[i] != v[i]) ++cntA;
    if(b[i] != v[i]) ++cntB;
    if(c[i] != v[i]) ++cntC;
  }

  return max(cntA, max(cntB, cntC));
}

int main() {

  if(!freopen(infile, "r", stdin))
	  terminate(0, infileMsg);
  if(scanf("%d", &n) != 1)
	  terminate(0, infileMsg);
  if(scanf("%s %s %s", a, b, c) != 3)
    terminate(0, infileMsg);
  fclose(stdin);


  if(!freopen(okfile, "r", stdin))
    terminate(0, okfileMsg);
  if(scanf("%s", ok) != 1)
    terminate(0, okfileMsg);
  fclose(stdin);


  if(!freopen(outfile, "r", stdin))
    terminate(0, outfileMsg);
  if(scanf("%s\n", out) != 1)
    terminate(0, wrongMsg);

  int resOut = compute(out);
  int resOk = compute(ok);

  if(resOut == resOk) terminate(pct, okMsg);
  else {
  	sprintf(customMsg, "%s Distanta obtinuta=%d Distanta corecta=%d", wrongMsg, resOut, resOk);
  	terminate(0, customMsg);
  }
  
  return 0;
}
