/* Andrei Parvu
   O(N * logN) + multimi disjuncte */

#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define x first
#define y second

const int NMAX = 200005;

int tata[NMAX], cate[NMAX], h[NMAX], adancime[NMAX], pozEuler[NMAX],
    culoare[NMAX];
pair<int, int> rmq[20][2 * NMAX];
int bit[2 * NMAX];
bool fst[NMAX];
long long valoare[NMAX];

vector<int> store[NMAX];
vector<int> v[NMAX];

int N, K, pozE;

void leg(int x, int y) {
  if (h[x] < h[y]) {
    tata[x] = y;
    cate[y] += cate[x];
  } else {
    if (h[x] == h[y]) {
      h[x] ++;
    }
    tata[y] = x;
    cate[x] += cate[y];
  }
}

int find(int x) {
  int y, z;

  for (y = x; tata[y]; y = tata[y]);

  for (; tata[x]; ) {
    z = tata[x];
    tata[x] = y;
    x = z;
  }

  return y;
}

void df(int nod, int ad = 0) {
  fst[nod] = 1;
  adancime[nod] = ad;

  pozE ++;
  rmq[0][pozE] = make_pair(nod, ad);
  pozEuler[nod] = pozE;

  store[culoare[nod]].push_back(nod);

  for (int i = 0; i < (int)v[nod].size(); i ++) {
    if (!fst[v[nod][i]]) {
      df(v[nod][i], ad + 1);
      rmq[0][++pozE] = make_pair(nod, ad);
    }
  }
}

int lca(int x, int y) {
  int p1 = pozEuler[x], p2 = pozEuler[y];

  if (p1 > p2) {
    swap(p1, p2);
  }

  int poz = bit[p2 - p1 + 1];

  if (rmq[poz][p1].y < rmq[poz][p2 - (1 << poz) + 1].y) {
    return rmq[poz][p1].x;
  }

  return rmq[poz][p2 - (1 << poz) + 1].x;
}

bool compara(pair<int, pair<int, int> > a, pair<int, pair<int, int> > b) {
  return adancime[a.x] > adancime[b.x];
}

int main() {
  freopen("kdist.in", "rt", stdin);
  freopen("kdist.out", "wt", stdout);

  scanf("%d%d", &N, &K);

  for (int i = 1; i < N; i ++) {
    int x, y;

    scanf("%d%d", &x, &y);

    v[x].push_back(y);
    v[y].push_back(x);
  }
  for (int i = 1; i <= N; i ++) {
    scanf("%d", culoare + i);
  }

  df(1);

  for (int i = 0; (1 << (i + 1)) <= pozE; i ++) {
    for (int j = 0; j + (1 << (i + 1)) - 1 <= pozE; j ++) {
      if (rmq[i][j].y < rmq[i][j + (1 << i)].y) {
        rmq[i + 1][j] = rmq[i][j];
      } else {
        rmq[i + 1][j] = rmq[i][j + (1 << i)];
      }
    }
  }

  int pow = 1;
  bit[1] = 0;
  for (int i = 2; i <= pozE; i ++) {
    if (i == (1 << pow)) {
      bit[i] = pow ++;
    } else {
      bit[i] = bit[i - 1];
    }
  }

  for (int i = 1; i <= N; i ++) {
    cate[i] = 1;
  }

  for (int cul = 1; cul <= K; cul ++) {
    //printf("Culoarea %d\n", cul);

    if (store[cul].size() <= 1) {
      printf("0\n");

      continue;
    }

    for (int i = 0; i < (int)store[cul].size(); i ++) {
      valoare[cul] += (long long)(store[cul].size() - 1) *
                      (long long)adancime[store[cul][i]];
    }

    vector<pair<int, pair<int, int> > > noduri;

    for (int i = 1; i < (int)store[cul].size(); i ++) {
      int x = lca(store[cul][i - 1], store[cul][i]);

      noduri.push_back(make_pair(x, make_pair(store[cul][i - 1],
              store[cul][i])));
    }

    sort(noduri.begin(), noduri.end(), compara);

    for (int i = 0; i < (int)noduri.size(); i ++) {
      int x = noduri[i].y.x,
          y = noduri[i].y.y;

      //printf("avem %d %d %d\n", noduri[i].x, x, y);

      valoare[cul] -= 2 * (long long)adancime[noduri[i].x] *
                          (long long)cate[find(x)] *
                          (long long)cate[find(y)];

      leg(find(x), find(y));
    }

    printf("%lld\n", valoare[cul]);
  }

  return 0;
}

