/* Andrei Ciocan
   O(N*log*N) cu alogoritmul lui Tarjan */

#include<fstream>
#include<iostream>
#include<vector>


#define maxval 200005

using namespace std;

int n,k,cul[maxval],info[maxval],R[maxval],G[maxval],sw[maxval],t[maxval];

long long level[maxval],nr[maxval], sol[maxval];

vector <pair<int , int > > a[maxval] , lca[maxval];
vector<int> v[maxval];

void solve()
{
	int	i,X,Y,ind ;
	vector<pair<int , int  > > :: iterator it ; 
	
	for (i=1;i<=n;i++) { nr[i]=1; R[i]=G[i]=0; }
	
	for (i=1;i<=n;i++)
		for (it=a[i].begin();it<a[i].end();it++) {
			ind=(*it).first;
			sol[i]+=(long long)(a[i].size()-1)*(level[ind]-1);
			R[ind]=ind;
			G[ind]=1;
		}
	
	for (i=n;i>=1;i--) 
		for (it=lca[i].begin();it<lca[i].end();++it) {
			
			for (X=a[(*it).first][(*it).second].first; X!=R[X]; X=R[X]);
			for (Y=a[(*it).first][(*it).second-1].first; Y!=R[Y]; Y=R[Y]);
			
			sol[(*it).first]-=(long long)(i-1)*nr[X]*nr[Y]*2;
			
			if (G[X]>=G[Y]) { 
				R[Y]=X;
				if (G[X]==G[Y])
					G[X]++;
			}
			else 
				R[X]=Y;
			
			nr[R[X]]=nr[X]+nr[Y];
		}
}

long long get( int x )
{
	int X;
	for (X=x;X!=R[X];X=R[X]); 
	for (int y;x!=R[x]; y=x, x=R[x], R[y]=X ); 
	return info[X];
}

void euler (int i)
{
	vector<int  > :: iterator it ;
	
	int Ri,Rit;
	
	R[i]=info[i]=i; G[i]=1; int color=cul[i];
	
	if (a[color].size()==0) 
		a[color].push_back(make_pair(i,0));
	else  {
	
		a[color].push_back (make_pair(i , get(a[color][a[color].size()-1].first)));
	    lca[level[a[color][a[color].size()-1].second]].push_back(make_pair(color,a[color].size()-1));
	}	
		
	for (it=v[i].begin();it<v[i].end();++it)
		if (t[i]!=*it) {
			euler(*it);
			
			for (Ri=i;Ri!=R[Ri];Ri=R[Ri]);
			for (Rit=*it;Rit!=R[Rit]; Rit=R[Rit]);
			
			if (G[Ri]>G[Rit] )
				R[Rit]=Ri;
			else
				if (G[Ri]==G[Rit] ){
					R[Rit]=Ri;
					G[Ri]++;
				}
				else {
					R[Ri]=Rit;
					info[Rit]=info[Ri];
				}
		}
}

void df(int i )
{
	vector < int > :: iterator it ;
	sw[i]=1; level[i]=level[t[i]]+1;
	for (it=v[i].begin();it<v[i].end();++it)
		if (sw[*it]==0) {
			t[*it]=sw[*it]=i;
			df(*it);
		}
}

void citire()
{
	int i,a,b;
	ifstream f("kdist.in");
	f>>n>>k;
	for (i=1;i<n;i++) {
		f>>a>>b;
		v[a].push_back(b);
		v[b].push_back(a);
	}
	
	for (i=1;i<=n;i++)
		f>>cul[i];
	f.close();
}

void afisare()
{
	ofstream f("kdist.out");
	for (int i=1;i<=k;i++)
		if (a[i].size())  f<<sol[i]<<endl;
    else
      f << 0 << endl;
	f.close();
}

int main()
{
	citire();
	df(1);
	euler(1);
	solve();
	afisare();
	return 0;
}
