//Marius Stroe O(M^2 +log N)
#include <iostream>
#include <cassert>
using namespace std;

const char iname[] = "retea.in";
const char oname[] = "retea.out";

const int MAX_N = 1005;
const int Modulo = 666013;

typedef long long i64;

int C[MAX_N][MAX_N], rows, cols;

int main(void) {
    fscanf(fopen(iname, "r"), "%d %d", &rows, &cols);
    assert(1 <= rows && rows <= 1e9);
    assert(1 <= cols && cols <= 1e3);

    int size = cols;
    C[1][1] = 2;
    for (int i = 2; i <= size; ++ i)
        C[i][1] = (C[i - 1][1] * 2) % Modulo;
    for (int j = 2; j <= size; ++ j)
        C[1][j] = (C[1][j - 1] * 2) % Modulo;
    for (int i = 2; i <= size; ++ i) {
        for (int j = 2; j <= size; ++ j) {
            C[i][j] = (2 * C[i - 1][j] + 2 * C[i][j - 1] - 2 * C[i - 1][j - 1]) % Modulo;
            if (C[i][j] < 0)
                C[i][j] += Modulo;
        }
    }
    int base = C[size][size];
    int exp = rows - 1;
    i64 r = 1;
    for (int i = 31; i >= 0; -- i) {
        r = (r * r) % Modulo;
        if (exp & (1 << i))
            r = (r * base) % Modulo;
    }
    fprintf(fopen(oname, "w"), "%lld\n", r);

    return 0;
}
