//Marius Stroe O(M^3 + log N)
#include <iostream>
#include <cassert>
using namespace std;

const char iname[] = "retea.in";
const char oname[] = "retea.out";

const int MAX_N = 1005;
const int Modulo = 666013;

typedef long long i64;

i64 C[MAX_N][MAX_N];  int rows, cols;

int main(void) {
    fscanf(fopen(iname, "r"), "%d %d", &rows, &cols);
    assert(1 <= rows && rows <= 1e9);
    assert(1 <= cols && cols <= 1e3);

    int size = cols;
    int p2[MAX_N] = {1};
    for (int i = 1; i <= size; ++ i)
        p2[i] = (p2[i - 1] * 2) % Modulo;
    for (int i = 1; i <= size; ++ i)
        C[i][1] = C[1][i] = p2[i];
    for (int i = 2; i <= size; ++ i) {
        for (int j = 2; j <= size; ++ j) {
            C[i][j] = C[i - 1][j];
            for (int k = 1; k <= j; ++ k) {
                C[i][j] = (C[i][j] + p2[k - 1] * C[i - 1][j - k + 1]) % Modulo;
            }
        }
    }

    int base = C[size][size];
    int exp = rows - 1;
    i64 r = 1;
    for (int i = 30; i >= 0; -- i) {
        r = (r * r) % Modulo;
        if (exp & (1 << i))
            r = (r * base) % Modulo;
    }
    fprintf(fopen(oname, "w"), "%lld\n", r);

    return 0;
}
